; Microplanet Gravity X-Face patch

; Gravity version		Macro
; Gravity 2.50 build 2000	GRAVITY_VERSION_2_5
; Gravity 2.30 build 1800	GRAVITY_VERSION_2_3

%ifndef GRAVITY_VERSION_2_5
%ifndef GRAVITY_VERSION_2_3
%error No Gravity version defined; use -D switch
%endif
%endif

bits 32
org 04002e8h					; start code in filler zeroes in Gravity.exe

%include "macros.inc"
%include "win32.inc"

%include "gravity_imports.inc"

; -----------------------------------------------------------------------------
; variables

; these point far into the .data section - hopefully alignment filler zeroes,
; it's probably safe to use for read/write vars

absolute 00605ef0h

initialized	resb 1
disabled	resb 1

; address of patch() function in WinFace.exe
patch		resd 1

err_msg_ptr	resd 1

; -----------------------------------------------------------------------------

[section .text]

		; [ebp+17]: ptr to article all headers, ASCIIZ
                ; Original multiline headers have been put on one line by Gravity!

patch_code:
                pushfd                          ; we need flags to return to the original code

		cmp	byte [disabled], 1
		je	.disabled

		pushad

		cmp	byte [initialized], 1
		je	short .already_initialized

                mov 	byte [disabled], 1

		; load WinFace.dll

		invoke	KERNEL32.LoadLibraryA, dword library_name
		test	eax, eax
		jnz	short .ok1
		mov	ebx, error_text
		jmp	short .show_lasterror

.ok1:

		invoke	KERNEL32.GetProcAddress, eax, dword func_name
		test	eax, eax
		jnz	short .ok2
		mov	ebx, error_text2
		jmp	short .show_lasterror
.ok2:

		mov	dword [patch], eax

.already_initialized:

		push	dword [ebp+17]
		call	dword [patch]
		test	eax, eax
		jnz	short .ok3
		mov	eax, error_text3
		mov	ebx, patch_name
		jmp	short .show_error

.ok3:

                mov 	byte [disabled], 0
		mov	byte [initialized], 1

		jmp	short .return
.show_lasterror:

		invoke	KERNEL32.GetLastError
		invoke	KERNEL32.FormatMessageA, dword FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_ALLOCATE_BUFFER, byte 0, eax, byte 0, dword err_msg_ptr, byte 0, byte 0
		mov	eax, [err_msg_ptr]

.show_error:
		invoke	USER32.MessageBoxA, 0, eax, ebx, 0
.error:
		mov	byte [disabled], 1

.return:
		popad
.disabled:
		; repair patched instruction

		popf

%ifdef GRAVITY_VERSION_2_5
		jnz	0407927h
		jmp	0407647h
%elifdef GRAVITY_VERSION_2_3
		jnz	0407bf7h
		jmp	0407917h
%endif

; -----------------------------------------------------------------------------

; read-only constants (really can't write to these)

error_text	db	"Can't load "
library_name	db	"WinFace.dll", 0

error_text2	db	"GetProcAddress failed", 0
error_text3	db	"patch failed", 0

patch_name	db	"X-Face "
func_name	db	"patch", 0